#### POSIX Threads for Windows – REFERENCE - Pthreads-w32

Reference Index

Table of Contents

## Name

pthread_barrierattr_destroy, pthread_barrierattr_init - destroy and initialize the barrier attributes object (ADVANCED REALTIME THREADS)

## Synopsis

#include <pthread.h>

int pthread_barrierattr_destroy(pthread_barrierattr_t *attr);
int pthread_barrierattr_init(pthread_barrierattr_t *attr);

## Description

The pthread_barrierattr_destroy function shall destroy a barrier attributes object. A destroyed attr attributes object can be reinitialized using pthread_barrierattr_init ; the results of otherwise referencing the object after it has been destroyed are undefined. An implementation may cause pthread_barrierattr_destroy to set the object referenced by attr to an invalid value.

The pthread_barrierattr_init function shall initialize a barrier attributes object attr with the default value for all of the attributes defined by the implementation.

Results are undefined if pthread_barrierattr_init is called specifying an already initialized attr attributes object.

After a barrier attributes object has been used to initialize one or more barriers, any function affecting the attributes object (including destruction) shall not affect any previously initialized barrier.

## Return Value

If successful, the pthread_barrierattr_destroy and pthread_barrierattr_init functions shall return zero; otherwise, an error number shall be returned to indicate the error.

## Errors

The pthread_barrierattr_destroy function may fail if:

EINVAL
  The value specified by attr is invalid.

The pthread_barrierattr_init function shall fail if:

ENOMEM
  Insufficient memory exists to initialize the barrier attributes object.

These functions shall not return an error code of [EINTR].

The following sections are informative.

## Examples

None.

## Application Usage

The pthread_barrierattr_destroy and pthread_barrierattr_init functions are part of the Barriers option and need not be provided on all implementations.

Pthreads-w32 defines _POSIX_BARRIERS to indicate that these routines are implemented and may be used.

## Rationale

None.

## Future Directions

None.

## See Also

pthread_barrierattr_getpshared(3) , pthread_barrierattr_setpshared(3) , the Base Definitions volume of IEEE Std 1003.1-2001, <pthread.h>.

## Copyright

Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .

Modified by Ross Johnson for use with Pthreads-w32.

Table of Contents

- Name

- Synopsis

- Description

- Return Value

- Errors

- Examples

- Application Usage

- Rationale

- Future Directions

- See Also

- Copyright